import java.io.*;
import java.util.*;
import javax.ejb.EJBObject;
import java.rmi.RemoteException;

public interface  Database  extends  EJBObject {

	//  modifer  public ..........
	public  String makeField(String str) throws RemoteException;
	public  boolean ssnExist(String ssn) throws RemoteException;
	public  boolean symbolExist(String symbol) throws RemoteException;
	public void addCustomer(String ssn, String name, String address) throws DuplicateIDException, RemoteException;
	public void deleteCustomer(String ssn) throws RecordNotFoundException , RemoteException;
	public void updateCustomer(String ssn, String name, String address) throws RecordNotFoundException , RemoteException;
	public CustomerRec getCustomer(String ssn) throws  RecordNotFoundException, RemoteException;
	public CustomerRec [] getAllCustomers()  throws RemoteException;
	public Vector getPortfolio(String ssn) throws  RecordNotFoundException ,RemoteException;
	public StockRec [] getAllStocks() throws RemoteException;
	public void sellShares(String ssn,String symbol,int quantity) throws RecordNotFoundException, InvalidTransactionException , RemoteException;
	public void buyShares(String ssn,String symbol,int quantity) throws RecordNotFoundException , RemoteException;
	public void updateStockPrice(String symbol, float price) throws  RecordNotFoundException , RemoteException;
	public float getStockPrice(String symbol) throws RecordNotFoundException ,RemoteException;
}