import java.sql.*;
import java.io.*;
import java.util.*;
import javax.sql.DataSource;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import java.rmi.*;

import javax.transaction.UserTransaction;

public class DatabaseEJB  implements SessionBean {


	private DataSource dataFactory;
	private SessionContext sc;

	 public DatabaseEJB(){
System.out.println("DatabaseEJB() ȣ");	
	 }
	 public void ejbCreate(){
System.out.println("ejbCreate() ȣ");
			try{
				 Context ctx = new InitialContext();
				  dataFactory  = (DataSource)ctx.lookup("java:comp/env/jdbc/BrokerDB");
			}catch(Exception e){
				e.printStackTrace();
			}
	 } // end ejbCreate()
	
	 public void ejbRemove(){
System.out.println("ejbRemove()");

	 }

	 public void setSessionContext(SessionContext sc){
System.out.println("setSessionContext() ȣ");
			
			 this.sc  = sc;
	 }
	 public void ejbActivate(){
System.out.println("ejbActivate()");

	 }
	 public void ejbPassivate(){
System.out.println("ejbPassivate()");

	 }


	//  (str =  -> return '')
	public  String makeField(String str) {
		return " '" + str + "' ";
	}

	// ssn customer table ִ ˻
	public  boolean ssnExist(String ssn) throws RemoteException {
	System.out.println("ssnExist.ssn>>" + ssn );

		String query = "SELECT * FROM customer WHERE ssn=" + makeField(ssn);
			  Connection con = null;
			Statement  stmt = null;
			ResultSet rset = null;

		try {
				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();

				  	rset = stmt.executeQuery(query);
			return rset.next();
		} catch(SQLException sqle) {
			System.out.println("Database.ssnExist() : " + sqle);
			return false;
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}
	}

	// symbol stock table ִ ˻
	public  boolean symbolExist(String symbol) throws  RemoteException{
	System.out.println("symbolExist.symbol>>" + symbol );

		String query = "SELECT * FROM stock WHERE symbol = " + makeField(symbol);
			  Connection con = null;
			Statement  stmt = null;
			ResultSet rset = null;

		try {

				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();

				  	rset = stmt.executeQuery(query);
			return rset.next();
		} catch (SQLException sqle) {
			System.out.println("Database.symbolExist() : " + sqle);
			return false;
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}

	}

	// ο  ߰
	public void addCustomer(String ssn, String name, String address) throws DuplicateIDException ,RemoteException{
	System.out.println("addCustomer.ssn>>" + ssn );

		if ( ssnExist(ssn) ) {
			throw new DuplicateIDException();
		}

		String query="INSERT INTO customer (ssn, cust_name, address) VALUES(";
		query = query + makeField(ssn);
		query = query + "," + makeField(name);
		query = query + "," + makeField(address);
		query = query + ")"; 
			  Connection con = null;
			Statement  stmt = null;
		try {

				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();

			stmt.executeUpdate(query);
		} catch(SQLException sqle) {
			System.out.println("Database.addCustomer() : " + sqle);
		}finally{
			
			  try{
				
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}

	}

	//  
	public void deleteCustomer(String ssn) throws RecordNotFoundException ,RemoteException{
				System.out.println("deleteCustomer.ssn : " + ssn);

		if ( !ssnExist(ssn) ) {
			throw new RecordNotFoundException();
		}
				 Connection  con  = null;
				 Statement  stmt = null;

		String queryCustomer = "DELETE FROM customer WHERE ssn = " + makeField(ssn);
		try {
				
				System.out.println( queryCustomer );
				con  = dataFactory.getConnection();
				stmt = con.createStatement();
			//deleteShares( ssn ) ȣ
			deleteShares( ssn );
		System.out.println(" int num = 3/0" );
			 int num = 3/0; //  ø̼ ܴ ڵ ѹ ʴ´. ݵ setRollbackOnly() ȣؾѴ.
			 if ( stmt.executeUpdate(queryCustomer) > 0 ) System.out.println( "deleteCustomer ");
		} catch(Exception sqle1) {
					System.out.println("deleteCustomer error 1");
					  sc.setRollbackOnly();
		}finally{
			  try{
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}
	}
	public void deleteShares( String ssn ){

		System.out.println("deleteShares.ssn : " + ssn);
				 Connection  con  = null;
				 Statement  stmt = null;
		String queryShares = "DELETE FROM shares WHERE ssn = " + makeField(ssn);

		try {
							System.out.println( queryShares );
				con  = dataFactory.getConnection();
				stmt = con.createStatement();
			    if ( stmt.executeUpdate(queryShares) >0 ) System.out.println( "deleteShares " );		
		} catch(Exception sqle1) {
					System.out.println("deleteShares error 1");
		}finally{
			
			  try{
				
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}

	}//

	//  
	public void updateCustomer(String ssn, String name, String address) throws RecordNotFoundException,RemoteException {
	System.out.println("updateCustomer.ssn>>" + ssn );

		if ( !ssnExist(ssn) ) {
			throw new RecordNotFoundException();
		}

		String query = "UPDATE customer SET cust_name = " + makeField(name);
		query = query + ", address = " + makeField(address);
		query = query + " WHERE ssn = " + makeField(ssn);
			  Connection con = null;
			Statement  stmt = null;

		try {

				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();

			stmt.executeUpdate(query);
		} catch(SQLException sqle) {
			System.out.println("Database.updateCustomer() : " + sqle);
		}finally{
			
			  try{
				
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}

	}

	//  
	public CustomerRec getCustomer(String ssn) throws RecordNotFoundException,RemoteException {
	System.out.println("getCustomer.ssn>>" + ssn );

	System.out.println("ssn>>" + ssn );
		if ( !ssnExist(ssn) ) {

	System.out.println("ssn  .>>" + ssn );
			throw new RecordNotFoundException();
		}

		String query = "SELECT * FROM customer WHERE ssn = " + makeField(ssn);
		String name, address;
		Vector portfolio;
			  Connection con = null;
			Statement  stmt = null;
			ResultSet rset = null;

		CustomerRec result = null;

		try {
				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();


					rset = stmt.executeQuery(query);
			rset.next();
			name = rset.getString("cust_name");
			address = rset.getString("address");
			portfolio = getPortfolio(ssn);

			result = new CustomerRec(ssn, name, address, portfolio);
		} catch (SQLException sqle) {
			System.out.println("Database.getCustomer() : " + sqle);
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}


		return result;
	}

	// ü  Ʈ
	public CustomerRec [] getAllCustomers() throws RemoteException{
	System.out.println("getAllCustomers" );
	

		String queryCount = "SELECT COUNT(*) FROM customer";
		String querySelect = "SELECT * FROM customer ORDER BY ssn";
			  Connection con = null;
			Statement  stmt = null;
			ResultSet rset = null;

		CustomerRec [] custAll = null;
		String name, ssn, address;

		int count = 0;

		try {
				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();


			rset = stmt.executeQuery(queryCount);
			rset.next();
			count = rset.getInt(1);

			custAll = new CustomerRec[count];
			rset = stmt.executeQuery(querySelect);

			for(int i=0; rset.next(); i++) {
				ssn = rset.getString("ssn");
				name = rset.getString("cust_name");
				address = rset.getString("address");
				custAll[i] = new CustomerRec(ssn, name, address);
			}
		} catch (SQLException sqle) {
			System.out.println("Database.getAllCustomers() : " + sqle);
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}


		return custAll;
	}

	//   ֽ Ʈ
	public Vector getPortfolio(String ssn) throws RecordNotFoundException,RemoteException {
	System.out.println("getPortfolio.ssn>>" + ssn );

		if ( !ssnExist(ssn) ) {
			throw new RecordNotFoundException();
		}

		Vector portfolio = new Vector();
		String query = "SELECT * FROM shares WHERE ssn = " + makeField(ssn);
			  Connection con = null;
			Statement  stmt = null;
			ResultSet rset = null;

		String symbol;
		int quantity;

		SharesRec sharesRec;

		try {

				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();

					rset = stmt.executeQuery(query);

			while( rset.next() ) {
				symbol = rset.getString("symbol");
				quantity = rset.getInt("quantity");
				sharesRec = new SharesRec(ssn, symbol, quantity);
				portfolio.add(sharesRec);
			}
		} catch (SQLException sqle) {
			System.out.println("Database.getPortfolio() : " + sqle);
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}


		return portfolio;
	}

	// ü ֽ Ʈ
	public StockRec [] getAllStocks() throws RemoteException{
	System.out.println("getAllStocks()" );

		String queryCount = "SELECT COUNT(*) FROM stock";
		String querySelect = "SELECT * FROM stock";
			  Connection con = null;
			Statement  stmt = null;
			Statement stmt2 = null;
			ResultSet rset = null;

		StockRec [] stockAll = null;
		String symbol;
		float price;

		int count = 0;

		try {
				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();
				   stmt2 = con.createStatement();


			 rset = stmt.executeQuery(queryCount);
			rset.next();
			count = rset.getInt(1);

			stockAll = new StockRec[count];
			rset = stmt2.executeQuery(querySelect);

			for (int i=0; rset.next(); i++) {
				symbol = rset.getString("symbol");
				price = rset.getFloat("price");
				stockAll[i] = new StockRec(symbol, price);
			}
		} catch (SQLException sqle) {
			System.out.println("Database.getAllStocks() : " + sqle);
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   stmt2.close();
				   con.close();
			  }catch( Exception e){}
			
		}


		return stockAll;
	}

	//   Ư ֽ ȱ
	public void sellShares(String ssn,String symbol,int quantity) throws RecordNotFoundException, InvalidTransactionException,RemoteException {

			System.out.println("sellShares.ssn : " + ssn);

		if ( !ssnExist(ssn) ) {
			throw new RecordNotFoundException();
		}

		String query = "SELECT quantity FROM shares WHERE ssn = " + makeField(ssn);
		query = query + " AND symbol = " + makeField(symbol);
			  Connection con = null;
			Statement  stmt = null;
			ResultSet rset = null;

try {

					   con  = dataFactory.getConnection();
				   stmt = con.createStatement();

	rset = stmt.executeQuery(query);

	if ( rset.next() ) {

		int quantDB = rset.getInt("quantity");

		if ( quantity > quantDB ) {
			throw new InvalidTransactionException("ֽ  ڶϴ.");
		} else if ( quantity == quantDB ) {
			query = "DELETE FROM shares WHERE ssn = " + makeField(ssn);
			query = query + " AND symbol = " + makeField(symbol);
		} else {
			query = "UPDATE shares SET quantity = quantity - ";
			query = query + quantity;
			query = query + " WHERE ssn = " + makeField(ssn);
			query = query + " AND symbol = " + makeField(symbol);
		}

				stmt.executeUpdate(query);
			} else {
				throw new InvalidTransactionException("ֽ ϰ  ʽϴ.");
			}
		} catch (SQLException sqle) {
			System.out.println("Database.sellShares()-UPDATE query : " + sqle);
			System.out.println("Query is -> " + query);
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}

	}

	//  Ư ֽ 
	public void buyShares(String ssn,String symbol,int quantity) throws RecordNotFoundException ,RemoteException{

			System.out.println("buyShares.ssn : " + ssn);

		if ( !ssnExist(ssn) ) {
			throw new RecordNotFoundException();
		}

		String query = "SELECT * FROM shares WHERE ssn = " + makeField(ssn);
		query = query + " AND symbol = " + makeField(symbol);
			  Connection con = null;
			Statement  stmt = null;
			ResultSet rset = null;

		try {

				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();


			       rset = stmt.executeQuery(query);

			if ( rset.next() ) {
				query = "UPDATE shares SET quantity = quantity + " + quantity;
				query = query + " WHERE ssn = " + makeField(ssn);
				query = query + " AND symbol = " + makeField(symbol);
			} else {
				query = "INSERT INTO shares VALUES(";
				query = query + makeField(ssn);
				query = query + "," + makeField(symbol);
				query = query + "," + quantity;
				query = query + ")";
			}

			stmt.executeUpdate(query);
		} catch (SQLException sqle) {
			System.out.println("Database.buyShares() : " + sqle);
			System.out.println("Query is -> " + query);
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}

	}

	// ֽ  
	public void updateStockPrice(String symbol, float price) throws RecordNotFoundException ,RemoteException{

			System.out.println("updateStockPrice.symbol : " + symbol);

		if ( !symbolExist(symbol) ) {
			throw new RecordNotFoundException();
		}

		String query = "UPDATE stock SET price = " + price;
		query = query + " WHERE symbol = " + makeField(symbol);
			  Connection con = null;
			Statement  stmt = null;

		try {

				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();

			stmt.executeUpdate(query);
		} catch (SQLException sqle) {
			System.out.println("Database.updateStockPrice() : " + sqle);
		}finally{
			
			  try{
				
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}

	}

	// Ư ֽ 
	public float getStockPrice(String symbol) throws RecordNotFoundException,RemoteException {
			System.out.println("getStockPrice.symbol : " + symbol);

		if ( !symbolExist(symbol) ) {
			throw new RecordNotFoundException();
		}

		float price = 0.0F;
		String query = "SELECT price FROM stock WHERE symbol = " + makeField(symbol);
			
			  Connection con = null;
			Statement  stmt = null;
			ResultSet rset = null;
		try {

				   con  = dataFactory.getConnection();
				   stmt = con.createStatement();

				  rset = stmt.executeQuery(query);
			rset.next();

			price = rset.getFloat(1);
		} catch (SQLException sqle) {
			System.out.println("Database.getStockPrice() : " + sqle);
		}finally{
			
			  try{
				
				   rset.close();
				   stmt.close();
				   con.close();
			  }catch( Exception e){}
			
		}


		return price;
	}
}